/*
 *  CheckerMaterial.cpp
 *  Assignment7
 *
 *  Created by Zach Gildersleeve on 3/10/07.
 *  Copyright 2007 __MyCompanyName__. All rights reserved.
 *
 */

#include "CheckerMaterial.h"

CheckerMaterial::CheckerMaterial(const Point &newP1, const Vector &newV1,
								 const Vector &newV2, Material *newMaterial1,
								 Material *newMaterial2) :
								 p1(newP1), v1(newV1), v2(newV2), v3(0.0, 0.0, 0.0)
{
		material1 = newMaterial1;
		material2 = newMaterial2;
		v1 = v1 / v1.lengthSquared();
		v2 = v2 / v2.lengthSquared();							 
}

CheckerMaterial::CheckerMaterial(const Point &newP1, const Vector &newV1,
								 const Vector &newV2, const Vector &newV3,
								 Material *newMaterial1, Material *newMaterial2) :
								 p1(newP1), v1(newV1), v2(newV2), v3(newV3)
{
		 material1 = newMaterial1;
		 material2 = newMaterial2;	
}

void CheckerMaterial::shade(Color &result, const RenderContext &context,
							const Ray &ray, const HitRecord &hit, int depth, const Color &attenuation) const
{
	Vector textCoord;
	
	hit.getPrimitive()->getTextCoord(textCoord, context, ray, hit);
	int i1 = Floor(dot(textCoord, v1));
	int i2 = Floor(dot(textCoord, v2));
	int i3 = Floor(dot(textCoord, v3));
	
	int cell = abs((i1 + i2 + i3) % 2);
	
	if (cell == 0)
		material1->shade(result, context, ray, hit, depth, attenuation);
	else
		material2->shade(result, context, ray, hit, depth, attenuation);
}
