/*
 *  Filter.cpp
 *  Assignment8
 *
 *  Created by Zach Gildersleeve on 3/19/07.
 *  Copyright 2007 __MyCompanyName__. All rights reserved.
 *
 */

#include "Filter.h"
#include <math.h>
#include <stdio.h>

BoxFilter::BoxFilter(double newSupport = 2.0)
{
	support = newSupport;
}

double BoxFilter::getWeight(double x, double y) const
{
	return 1.0;
}

void BoxFilter::getWeights(double *weights, int samples, double *xs, double *ys) const
{
	for (int i = 0; i < samples; i++)
		weights[i] = getWeight(xs[i], ys[i]);
}



TriangleFilter::TriangleFilter(double newSupport = 2.0)
{
	support = newSupport;
	tent = support / 2.0;
//	printf("In TriangleFilter, support = %f\n", support);
}

double TriangleFilter::getWeight(double x, double y) const
{
	double _x = tent - fabs(x);
	if (_x < 0)
		return 0.0;
		
	double _y = tent - fabs(y);
	if (_y < 0)
		return 0.0;
		
	return _x * _y;
}

void TriangleFilter::getWeights(double *weights, int samples, double *xs, double *ys) const
{
	for (int i = 0; i < samples; i++)
		weights[i] = getWeight(xs[i], ys[i]);
}



GaussianFilter::GaussianFilter(double newSupport = 3.0)
{
	support = newSupport;
}

double GaussianFilter::getWeight(double x, double y) const
{
	return exp(-support * (x * x)) + exp(-support * (y * y));
}

void GaussianFilter::getWeights(double *weights, int samples, double *xs, double *ys) const
{
	for (int i = 0; i < samples; i++)
		weights[i] = getWeight(xs[i], ys[i]);
}