/*
 *  Filter.h
 *  Assignment8
 *
 *  Created by Zach Gildersleeve on 3/19/07.
 *  Copyright 2007 __MyCompanyName__. All rights reserved.
 *
 */

#ifndef FILTER_H
#define FILTER_H

class Filter
{
	public:
		Filter() {support = 2;}
		virtual ~Filter() {}
		
		virtual double getSupport() const = 0;
		virtual double getWeight(double x, double y) const = 0;
		virtual void getWeights(double *weights, int samples, double *xs, double *ys) const = 0;
		
		double support;
};

class BoxFilter : public Filter
{
	public:
		BoxFilter(double newSupport);
		double getSupport() const {return support;}
		double getWeight(double x, double y) const;
		void getWeights(double *weights, int samples, double *xs, double *ys) const;
};

class TriangleFilter : public Filter
{
	public:
		TriangleFilter(double newSupport);
		double getSupport() const {return support;}
		double getWeight(double x, double y) const;
		void getWeights(double *weights, int samples, double *xs, double *ys) const;
		
		double tent;
};

class GaussianFilter : public Filter
{
	public:
		GaussianFilter(double newSupport);
		double getSupport() const {return support;}
		double getWeight(double x, double y) const;
		void getWeights(double *weights, int samples, double *xs, double *ys) const;
};






#endif