/*
 *  HeightField.h
 *  Assignment4
 *
 *  Created by Zach Gildersleeve on 2/9/07.
 *  Copyright 2007 __MyCompanyName__. All rights reserved.
 *
 */

#ifndef HEIGHTFIELD_H
#define HEIGHTFIELD_H

#include "Primitive.h"
#include "Ray.h"
#include "HitRecord.h"


class HeightField : public Primitive {
	public:
		HeightField(Material *mat, char *name, const Point &newP1, const Point &newP2);
		~HeightField() {}
		
		virtual void getBounds(BoundingBox& bbox) const;
		virtual bool intersect(HitRecord &hit, const RenderContext &context, const Ray &ray) const;
		virtual void normal(Vector &normal, const Point &hitPoint, const HitRecord &hit, const RenderContext &context, const Ray &ray) const;
		
	private:
		Point pt[2];
		int nx, ny;
		float **data;
		float *p;
		
		Vector diagonal;
		Vector cellSize;
		Vector inverseCellSize;
		
		struct normalData {

			Point C;
			double Zu, Zv, Zuv;
		};
};

#endif