/*
 *  Image.h
 *  Assignment1
 *
 *  Created by Zach Gildersleeve on 1/17/07.
 *  Copyright 2007 __MyCompanyName__. All rights reserved.
 *
 */

#ifndef IMAGE_H
#define IMAGE_H

//#include <string>
#include "Point.h"
#include "Color.h"

class Color;
struct Pixel {
	unsigned char r;
	unsigned char g;
	unsigned char b;
};

class Image {
	public:
		Image(int w, int h);
		Image(const char *fileName);
		~Image();
		
		void set(int i, int j, const Color &result);
		void setPixel(int i, int j, const Color &result);
		void write(const char *name);
		
		inline int getWidth() {
			return width;
		}
		
		inline int getHeight() {
			return height;
		}
		
		inline double getAspectRatio() {
			return (double)(width) / (double)(height);
		}
		
		Color interpolate(double x, double y);
		
		Pixel **imageData;
		
		Image(const Image&);
		Image &operator=(const Image&);
		
	private:
		int width;
		int height;
};

#endif