/*
 *  PhongMarbleMaterial.h
 *  Assignment7
 *
 *  Created by Zach Gildersleeve on 3/11/07.
 *  Copyright 2007 __MyCompanyName__. All rights reserved.
 *
 */

#ifndef PHONGMARBLEMATERIAL_H
#define PHONGMARBLEMATERIAL_H

#include "Material.h"
#include "Color.h"
#include "Point.h"
#include "Ray.h"
#include "HitRecord.h"
#include "Scene.h"
#include "PerlinNoise.h"

class PhongMarbleMaterial : public Material {
		public:
			PhongMarbleMaterial(const Color &newColor1, const Color &newColor2,
								double newScale, int newOctaves, double newTurbulenceScale,
								double newFrequencyScale, double newLacunarity,
								double newGain, double newKdiffuse, double newKambient,
								const Color &newSpecColor, int newPhongTerm);
			virtual ~PhongMarbleMaterial() {}
		
			virtual void preprocess() {}
			
			void shade(Color &result, const RenderContext &context,
					   const Ray &ray, const HitRecord &hit, int depth, const Color &attenuation) const;
			
			
		
		private:
			Color color1;
			Color color2;
			
			double scale;
			int octaves;
			double turbulenceScale;
			double frequencyScale;
			double lacunarity;
			double gain;
			
			double Kambient;
			double Kdiffuse;
			Color specColor;
			int phongTerm;
};
										  
#endif