/*
 *  Ray.h
 *  Assignment1
 *
 *  Created by Zach Gildersleeve on 1/17/07.
 *  Copyright 2007 __MyCompanyName__. All rights reserved.
 *
 */

#ifndef RAY_H
#define RAY_H

#include "Point.h"
#include "Vector.h"

struct Sign {
	int x;
	int y;
	int z;
};


class Ray {
	public:
		Ray() {}
		Ray(const Ray &r) : origin(r.origin), direction(r.direction), sign(r.sign) {}
		
		inline Ray(const Point &newOrigin, const Vector &newDirection) : origin(newOrigin), direction(newDirection) {
			inverseDirection = Vector(1.0/direction.x, 1.0/direction.y, 1.0/direction.z);
			
			sign.x = (inverseDirection.x < 0);
			sign.y = (inverseDirection.y < 0);
			sign.z = (inverseDirection.z < 0);
		}
		
		inline ~Ray() {}
		
		Ray &operator=(const Ray &r) {
			origin = r.origin;
			direction = r.direction;
			inverseDirection = r.inverseDirection;
			sign = r.sign;
			return *this;
		}
		
		const Point &getOrigin() const {
			return origin;
		}
		
		const Vector &getDirection() const {
			return direction;
		}
			
//	private:
		Point origin;
		Vector direction;
		Vector inverseDirection;
		Sign sign;
	
};

#endif