/*
 *  Ring.h
 *  Assignment3
 *
 *  Created by Zach Gildersleeve on 2/4/07.
 *  Copyright 2007 __MyCompanyName__. All rights reserved.
 *
 */

#ifndef RING_H
#define RING_H

#include "Primitive.h"
#include "Ray.h"
#include "HitRecord.h"
#include "BoundingBox.h"

class Ring : public Primitive {
	public:
		Ring(Material *newMaterial, const Point &newCenter, const Vector &newNormal, double newInnerRadius, double newOuterRadius);
	
		virtual ~Ring() {
		}
		virtual void getBounds(BoundingBox& bbox) const;	
		virtual bool intersect(HitRecord &hit, const RenderContext &context, const Ray &ray) const;
		virtual void normal(Vector &normal, const Point &hitPoint, const HitRecord &hit, const RenderContext &context, const Ray &ray) const;

	private:
		Point center;
		Vector normalVector;
		
		double d;
		double innerRadius;
		double outerRadius;
		double innerRadiusSquared;
		double outerRadiusSquared;
};

#endif