/*
 *  Sampler.cpp
 *  Assignment8
 *
 *  Created by Zach Gildersleeve on 3/19/07.
 *  Copyright 2007 __MyCompanyName__. All rights reserved.
 *
 */

#include "Sampler.h"
#include <stdlib.h>

UniformSampler::UniformSampler(int number)
{
	numberSamples = number;
	inverseSamples = 1.0 / numberSamples;
	invSamplesMult = inverseSamples * 0.5;
}

void UniformSampler::getSamples(double x, double y, int support, double *xs, double *ys)
{
	//double inverseSamples = 1.0 / numberSamples;
	double filterMin = -0.5 * (double)(support) + invSamplesMult;// 0.5 * inverseSamples;
	int totalSteps = numberSamples * support;
	
	for (int i = 0; i < totalSteps; i++)
	{
		for (int j = 0; j < totalSteps; j++)
		{
			xs[i * totalSteps + j] = filterMin + inverseSamples * i;
			ys[i * totalSteps + j] = filterMin + inverseSamples * j;
		}
	}
}

JitteredSampler::JitteredSampler(int number)
{
	numberSamples = number;
	inverseSamples = 1.0 / numberSamples;
	invSamplesMult = inverseSamples * 0.5;
}

void JitteredSampler::getSamples(double x, double y, int support, double *xs, double *ys)
{
//	double inverseSamples = 1.0 / numberSamples;
	double filterMin = -0.5 * (double)(support) + invSamplesMult;//0.5 * inverseSamples;
	int totalSteps = numberSamples * support;
	
	for (int i = 0; i < totalSteps; i++)
	{
		for (int j = 0; j < totalSteps; j++)
		{
			xs[i * totalSteps + j] = filterMin + inverseSamples * (i + drand48() - 0.5);
			ys[i * totalSteps + j] = filterMin + inverseSamples * (j + drand48() - 0.5);
		}
	}
}