/*
 *  WoodMaterial.h
 *  Assignment7
 *
 *  Created by Zach Gildersleeve on 3/16/07.
 *  Copyright 2007 __MyCompanyName__. All rights reserved.
 *
 */

#ifndef WOODMATERIAL_H
#define WOODMATERIAL_H

#include "Material.h"
#include "Color.h"
#include "Point.h"
#include "Ray.h"
#include "HitRecord.h"
#include "Scene.h"
#include "PerlinNoise.h"

class WoodMaterial : public Material
{
	public:
		WoodMaterial();
		virtual ~WoodMaterial() {}
	
		
		void shade(Color &result, const RenderContext &context,
				   const Ray &ray, const HitRecord &hit, int depth, const Color &attenuation) const;
		
	private:
		Color color1;
		Color color2;
		
		Vector grainScale;
		int grainOctaves;
		double grainTurbulence;
		double grainFrequency;
		double grainLacunarity;
		double grainGain;
		
		Vector ringScale;
		int ringOctaves;
		double ringTurbulence;
		double ringLacunarity;
		double ringGain;
		
		double Kambient;
		double Kdiffuse;
		Color specColor;
		int phongTerm;
};


#endif